﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

public partial class _Default : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (Session["GridData"] == null)
        {
            Session["GridData"] = GetEmployDepartmentDataSet();
            WebHierarchicalDataGrid1.DataSource = Session["GridData"];
            

            WebHierarchicalDataGrid1.GridView.Behaviors.Sorting.SortedColumns.Add(WebHierarchicalDataGrid1.GridView.Columns["DateOfCreate"], Infragistics.Web.UI.SortDirection.Ascending);
            WebHierarchicalDataGrid1.DataBind();
        }
        else
        {
            WebHierarchicalDataGrid1.DataSource = Session["GridData"];
        }
    }

    private DataSet GetEmployDepartmentDataSet()
    {
        DataSet ds = new DataSet("EmployeeRecords");

        // Get the tables to use in the DataSet
        DataTable Employees = this.GetEmployees();
        DataTable Departments = this.GetDepartments();
        DataTable Options = this.GetEmployeeOptions();

        // Add the tables to the DataSet
        ds.Tables.Add(Departments);
        ds.Tables.Add(Employees);
        ds.Tables.Add(Options);

        // Create the relationship between the tables.
        ds.Relations.Add("DepartmentEmployee", Departments.Columns["DepartmentID"], Employees.Columns["Department"]);
        ds.Relations.Add("EmployeeOption", Employees.Columns["EmployeeID"], Options.Columns["Employee"]);
        return ds;
    }

    private DataTable GetDepartments()
    {
        DataTable dt = new DataTable("Departments");
        dt.Columns.Add("DepartmentID", typeof(int));
        dt.Columns.Add("DepartmentName", typeof(string));
        dt.Columns.Add("DateOfCreate", typeof(DateTime));

        for (int i = 0; i < 8; i++)
        {
            dt.Rows.Add(new object[] { i, string.Format("Department {0}", i), DateTime.Today.Date.AddDays(-1 * i) });
        }

        dt.PrimaryKey = new DataColumn[] { dt.Columns["DepartmentID"] };

        return dt;
    }

    private DataTable GetEmployees()
    {
        return this.GetEmployees(24);
    }

    private DataTable GetEmployees(int count)
    {
        DataTable dtData = new DataTable("Employees");

        dtData.Columns.Add("EmployeeID", typeof(int));
        dtData.Columns.Add("Name", typeof(string));
        dtData.Columns.Add("Department", typeof(int));


        for (int i = 0; i < count; i++)
        {
            dtData.Rows.Add(new object[] { i, string.Format("Name {0}", i), i % 8 });
        }

        dtData.PrimaryKey = new DataColumn[] { dtData.Columns["EmployeeID"] };

        return dtData;
    }

    private DataTable GetEmployeeOptions()
    {
        DataTable dtData = new DataTable("EmployeeOptions");

        dtData.Columns.Add("OptionID", typeof(int));
        dtData.Columns.Add("Employee", typeof(int));
        dtData.Columns.Add("Option", typeof(string));
        dtData.Columns.Add("Description", typeof(string));


        for (int i = 0; i < 96; i++)
        {
            dtData.Rows.Add(new object[] { i, i % 24, string.Format("Option {0}", i), String.Format("Option Description {0}", i) });
        }

        dtData.PrimaryKey = new DataColumn[] { dtData.Columns["OptionID"] };

        return dtData;
    }
    protected void Button1_Click(object sender, EventArgs e)
    {

        WebHierarchicalDataGrid1.GroupingSettings.GroupedColumns.Clear();
        WebHierarchicalDataGrid1.DataBind();
    }
}